# Rax 样式支持列表

| 样式属性名                            | 支持度 (✕ 表示不支持；✓ 表示支持，〇 表示部分支持)      |
| -------------------------------- | ---------------------------------- |
| display                          | ✕ 只支持 `flex`                       |
| margin                           | 〇 (不支持合并写法)                        |
| width                            | ✓                                  |
| overflow                         | 〇 只支持 iOS, `hidden` 只在 Android 下可用 |
| background-color                 | ✓                                  |
| height                           | ✓                                  |
| font-size                        | ✓                                  |
| padding                          | ✓                                  |
| color                            | ✓                                  |
| text-align                       | ✓                                  |
| position                         | 〇 默认是 `relative` , 不支持 `static`    |
| font-family                      | ✓                                  |
| font-weight                      | ✓                                  |
| opacity                          | ✓                                  |
| max-width                        | ✓                                  |
| box-sizing                       | ✕ 只支持 `border-box`                 |
| max-height                       | ✓                                  |
| webkit-user-select               | ✕                                  |
| align-items                      | ✓                                  |
| justify-content                  | ✓                                  |
| flex-direction                   | ✓                                  |
| border                           | ✓                                  |
| top                              | ✓                                  |
| background                       | ✕                                  |
| cursor                           | ✕                                  |
| margin-left                      | ✓                                  |
| left                             | ✓                                  |
| text-decoration                  | ✓                                  |
| float                            | ✕                                  |
| border-bottom                    | ✓                                  |
| padding-left                     | ✓                                  |
| margin-top                       | ✓                                  |
| line-height                      | ✓                                  |
| background-image                 | ✕                                  |
| z-index                          | ✕                                  |
| right                            | ✓                                  |
| margin-bottom                    | ✓                                  |
| white-space                      | ✕                                  |
| margin-right                     | ✓                                  |
| vertical-align                   | ✕                                  |
| padding-top                      | ✓                                  |
| border-radius                    | ✓                                  |
| border-top                       | ✓                                  |
| padding-bottom                   | ✓                                  |
| padding-right                    | ✓                                  |
| visibility                       | ✕                                  |
| background-position              | ✕                                  |
| background-repeat                | ✕                                  |
| clear                            | ✕                                  |
| bottom                           | ✓                                  |
| content                          | ✕                                  |
| box-shadow                       | ✕                                  |
| border-color                     | ✓                                  |
| outline                          | ✕                                  |
| border-right                     | ✓                                  |
| border-left                      | ✓                                  |
| min-height                       | ✓                                  |
| font-style                       | ✓                                  |
| min-width                        | ✓                                  |
| list-style                       | ✕                                  |
| font                             | ✕                                  |
| background-size                  | ✕                                  |
| border-width                     | ✓                                  |
| border-collapse                  | ✕                                  |
| border-style                     | ✓                                  |
| text-overflow                    | 〇 必须和 `lines` 一起使用                 |
| text-transform                   | ✕                                  |
| transition                       | ✕                                  |
| overflow-y                       | ✕                                  |
| transform                        | ✕                                  |
| text-indent                      | ✕                                  |
| text-shadow                      | ✕                                  |
| webkit-appearance                | ✕                                  |
| list-style-type                  | ✕                                  |
| border-spacing                   | ✕                                  |
| word-wrap                        | ✕                                  |
| overflow-x                       | ✕                                  |
| zoom                             | ✕                                  |
| border-bottom-left-radius        | ✕                                  |
| pointer-events                   | ✕                                  |
| border-top-left-radius           | ✕                                  |
| border-bottom-color              | ✓                                  |
| border-top-color                 | ✓                                  |
| border-bottom-right-radius       | ✕                                  |
| border-top-right-radius          | ✕                                  |
| letter-spacing                   | ✕                                  |
| animation                        | ✕                                  |
| border-right-width               | ✓                                  |
| src                              | ✕                                  |
| clip                             | ✕                                  |
| webkit-font-smoothing            | ✕                                  |
| border-bottom-width              | ✓                                  |
| border-right-color               | ✓                                  |
| direction                        | ✓                                  |
| webkit-tap-highlight-color       | ✕                                  |
| border-left-color                | ✓                                  |
| border-top-width                 | ✓                                  |
| fill                             | ✕                                  |
| border-left-width                | ✓                                  |
| table-layout                     | ✕                                  |
| word-break                       | ✕                                  |
| background-clip                  | ✕                                  |
| transform-origin                 | ✕                                  |
| filter                           | ✕                                  |
| resize                           | ✕                                  |
| flex                             | ✓                                  |
| font-variant                     | ✕                                  |
| text-rendering                   | ✕                                  |
| webkit-filter                    | ✕                                  |
| transition-duration              | ✕                                  |
| transition-property              | ✕                                  |
| webkit-box-orient                | ✕                                  |
| outline-offset                   | ✕                                  |
| transition-timing-function       | ✕                                  |
| unicode-range                    | ✕                                  |
| word-spacing                     | ✕                                  |
| quotes                           | ✕                                  |
| border-bottom-style              | ✓                                  |
| webkit-background-clip           | ✕                                  |
| flex-grow                        | ✕                                  |
| backface-visibility              | ✕                                  |
| animation-name                   | ✕                                  |
| stroke                           | ✕                                  |
| animation-duration               | ✕                                  |
| touch-action                     | ✕                                  |
| list-style-position              | ✕                                  |
| order                            | ✕                                  |
| outline-width                    | ✕                                  |
| transition-delay                 | ✕                                  |
| border-top-style                 | ✓                                  |
| webkit-box-pack                  | ✕                                  |
| webkit-box-align                 | ✕                                  |
| page-break-inside                | ✕                                  |
| webkit-line-clamp                | ✕                                  |
| list-style-image                 | ✕                                  |
| page-break-after                 | ✕                                  |
| speak                            | ✕                                  |
| unicode-bidi                     | ✕                                  |
| animation-timing-function        | ✕                                  |
| webkit-box-flex                  | ✕                                  |
| orphans                          | ✕                                  |
| widows                           | ✕                                  |
| flex-wrap                        | ✓                                  |
| animation-fill-mode              | ✕                                  |
| animation-delay                  | ✕                                  |
| border-left-style                | ✓                                  |
| outline-color                    | ✕                                  |
| flex-shrink                      | ✕                                  |
| perspective                      | ✕                                  |
| border-right-style               | ✓                                  |
| outline-style                    | ✕                                  |
| animation-iteration-count        | ✕                                  |
| background-origin                | ✕                                  |
| fill-opacity                     | ✕                                  |
| will-change                      | ✕                                  |
| stroke-width                     | ✕                                  |
| transform-style                  | ✕                                  |
| overflow-wrap                    | ✕                                  |
| background-attachment            | ✕                                  |
| counter-increment                | ✕                                  |
| counter-reset                    | ✕                                  |
| align-self                       | ✓                                  |
| webkit-box-ordinal-group         | ✕                                  |
| webkit-animation-direction       | ✕                                  |
| background-position-x            | ✕                                  |
| border-image                     | ✕                                  |
| background-position-y            | ✕                                  |
| webkit-user-drag                 | ✕                                  |
| flex-basis                       | ✕                                  |
| align-content                    | ✓                                  |
| flex-flow                        | ✕                                  |
| image-rendering                  | ✕                                  |
| webkit-margin-start              | ✕                                  |
| font-stretch                     | ✕                                  |
| empty-cells                      | ✕                                  |
| webkit-margin-after              | ✕                                  |
| perspective-origin               | ✕                                  |
| webkit-margin-end                | ✕                                  |
| column-count                     | ✕                                  |
| webkit-text-fill-color           | ✕                                  |
| webkit-box-direction             | ✕                                  |
| font-feature-settings            | ✕                                  |
| webkit-mask-image                | ✕                                  |
| webkit-padding-end               | ✕                                  |
| stroke-dasharray                 | ✕                                  |
| user-select                      | ✕                                  |
| object-fit                       | ✕                                  |
| column-gap                       | ✕                                  |
| text-size-adjust                 | ✕                                  |
| caption-side                     | ✕                                  |
| stroke-dashoffset                | ✕                                  |
| stroke-linecap                   | ✕                                  |
| animation-direction              | ✕                                  |
| webkit-font-feature-settings     | ✕                                  |
| stroke-opacity                   | ✕                                  |
| stroke-miterlimit                | ✕                                  |
| fill-rule                        | ✕                                  |
| webkit-user-modify               | ✕                                  |
| webkit-border-image              | ✕                                  |
| animation-play-state             | ✕                                  |
| contain                          | ✕                                  |
| webkit-padding-start             | ✕                                  |
| webkit-margin-before             | ✕                                  |
| page-break-before                | ✕                                  |
| webkit-margin-top-collapse       | ✕                                  |
| columns                          | ✕                                  |
| webkit-mask-size                 | ✕                                  |
| border-image-slice               | ✕                                  |
| stop-color                       | ✕                                  |
| webkit-mask-repeat               | ✕                                  |
| webkit-box-lines                 | ✕                                  |
| webkit-column-break-inside       | ✕                                  |
| size                             | ✕                                  |
| font-kerning                     | ✕                                  |
| stroke-linejoin                  | ✕                                  |
| tab-size                         | ✕                                  |
| break-inside                     | ✕                                  |
| webkit-text-stroke-width         | ✕                                  |
| column-width                     | ✕                                  |
| webkit-mask-position             | ✕                                  |
| border-image-width               | ✕                                  |
| border-image-repeat              | ✕                                  |
| border-image-outset              | ✕                                  |
| all                              | ✕                                  |
| webkit-text-stroke-color         | ✕                                  |
| webkit-print-color-adjust        | ✕                                  |
| webkit-text-stroke               | ✕                                  |
| writing-mode                     | ✕                                  |
| clip-rule                        | ✕                                  |
| webkit-clip-path                 | ✕                                  |
| text-anchor                      | ✕                                  |
| shape-rendering                  | ✕                                  |
| webkit-column-break-before       | ✕                                  |
| clip-path                        | ✕                                  |
| webkit-mask                      | ✕                                  |
| mix-blend-mode                   | ✕                                  |
| text-align-last                  | ✕                                  |
| column-rule                      | ✕                                  |
| webkit-mask-box-image            | ✕                                  |
| font-variant-ligatures           | ✕                                  |
| column-fill                      | ✕                                  |
| webkit-line-break                | ✕                                  |
| border-image-source              | ✕                                  |
| stop-opacity                     | ✕                                  |
| webkit-perspective-origin-y      | ✕                                  |
| webkit-perspective-origin-x      | ✕                                  |
| webkit-writing-mode              | ✕                                  |
| dominant-baseline                | ✕                                  |
| column-rule-color                | ✕                                  |
| webkit-box-decoration-break      | ✕                                  |
| webkit-text-security             | ✕                                  |
| webkit-background-origin         | ✕                                  |
| font-variant-caps                | ✕                                  |
| column-rule-style                | ✕                                  |
| shape-outside                    | ✕                                  |
| webkit-padding-before            | ✕                                  |
| break-after                      | ✕                                  |
| webkit-padding-after             | ✕                                  |
| text-orientation                 | ✕                                  |
| webkit-text-orientation          | ✕                                  |
| mask                             | ✕                                  |
| alignment-baseline               | ✕                                  |
| page                             | ✕                                  |
| webkit-column-break-after        | ✕                                  |
| webkit-box-reflect               | ✕                                  |
| webkit-text-emphasis-color       | ✕                                  |
| object-position                  | ✕                                  |
| break-before                     | ✕                                  |
| webkit-margin-collapse           | ✕                                  |
| baseline-shift                   | ✕                                  |
| hyphens                          | ✕                                  |
| rx                               | ✕                                  |
| ry                               | ✕                                  |
| background-blend-mode            | ✕                                  |
| font-variant-numeric             | ✕                                  |
| background-repeat-x              | ✕                                  |
| background-repeat-y              | ✕                                  |
| webkit-text-emphasis             | ✕                                  |
| webkit-rtl-ordering              | ✕                                  |
| column-rule-width                | ✕                                  |
| isolation                        | ✕                                  |
| webkit-highlight                 | ✕                                  |
| webkit-transform-origin-y        | ✕                                  |
| webkit-transform-origin-x        | ✕                                  |
| webkit-app-region                | ✕                                  |
| column-span                      | ✕                                  |
| r                                | ✕                                  |
| y                                | ✕                                  |
| x                                | ✕                                  |
| webkit-border-vertical-spacing   | ✕                                  |
| webkit-border-horizontal-spacing | ✕                                  |
| webkit-border-start-width        | ✕                                  |
| webkit-border-start-color        | ✕                                  |
| webkit-border-after-width        | ✕                                  |
| webkit-border-before-width       | ✕                                  |
| webkit-border-end-width          | ✕                                  |
| marker                           | ✕                                  |
| webkit-border-end-color          | ✕                                  |
| webkit-border-after-color        | ✕                                  |
| webkit-border-before-color       | ✕                                  |
| mask-type                        | ✕                                  |
| color-interpolation-filters      | ✕                                  |
| webkit-border-end                | ✕                                  |
| vector-effect                    | ✕                                  |
| color-rendering                  | ✕                                  |